pipeline {
  agent {
        kubernetes {
            yaml """
                apiVersion: v1
                kind: Pod
                spec:
                  containers:
                  - name: alpine
                    image: alpine
                    command:
                    - sleep
                    args:
                    - 1d
            """
            defaultContainer 'alpine'
        }
  }
  parameters {
        string(name: 'GIT_TAG', defaultValue: '0.0.0', description: 'Git tag for build')
  }
  triggers {
   GenericTrigger(
     genericVariables: [
      [key: 'ref', value: '$.ref']
     ],

     causeString: 'Triggered on $ref',

     token: 'test-tag',
     tokenCredentialId: '',

     printContributedVariables: true,
     printPostContent: true,

     silentResponse: false,
     
     shouldNotFlatten: false,

     regexpFilterText: '$ref',
     regexpFilterExpression: 'refs/tags/*'
    )
  }

  stages {
    stage('Custom Checkout') {
            steps {
                script {
                  try {
                    checkout([$class: 'GitSCM', branches: [[name: "$ref"]]])
                  } catch (Exception e) {
                    checkout([$class: 'GitSCM', branches: [[name: "$GIT_TAG"]]])
                  }
                }
            }
    }

    stage('Some step') {
      steps {
        sh "cat test.txt"
        sh "printenv"
      }
    }
  }
}
